=== src/CMakeLists.txt ===
add_subdirectory(stdgpu)
