=== examples/openmp/CMakeLists.txt ===

stdgpu_add_example_cpp(atomic)
stdgpu_add_example_cpp(bitset)
stdgpu_add_example_cpp(deque)
stdgpu_add_example_cpp(iterator)
stdgpu_add_example_cpp(mutex_array)
stdgpu_add_example_cpp(ranges)
stdgpu_add_example_cpp(unordered_map)
stdgpu_add_example_cpp(unordered_set)
stdgpu_add_example_cpp(vector)
