=== benchmark/stdgpu/cuda/CMakeLists.txt ===

target_sources(benchmarkstdgpu PRIVATE bitset.cu
                                       deque.cu
                                       mutex.cu
                                       unordered_map.cu
                                       unordered_set.cu
                                       vector.cu)
