## stdgpu 1.3.0%2Bgit20220507.32e0517

=== debian/control ===
Source: stdgpu
Section: libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.26.4-3~),
 hipcc [amd64 ppc64el],
 libamdhip64-dev [amd64 ppc64el],
 libgtest-dev <!nocheck>,
 librocthrust-dev [amd64 ppc64el] | libthrust-dev,
Homepage: https://github.com/stotko/stdgpu
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/stdgpu.git
Vcs-Browser: https://salsa.debian.org/debian/stdgpu
Description: Efficient STL-like Data Structures on the GPU
 stdgpu is an open-source library providing several generic GPU data structures
 for fast and reliable data management. Multiple platforms such as CUDA,
 OpenMP, and HIP are supported allowing you to rapidly write highly complex
 agnostic and native algorithms that look like sequential CPU code but are
 executed in parallel on the GPU.

Package: libstdgpu-openmp0t64
Provides: ${t64:Provides}
X-Time64-Compat: libstdgpu-openmp0d
Replaces: libstdgpu-openmp0d
Breaks: libstdgpu-openmp0d (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (OpenMP CPU backend)
 ${source:Extended-Description}
 .
 This package installs the shared library that runs on the CPU with OpenMP.

Package: libstdgpu-openmp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libstdgpu-dev
Provides: libstdgpu-dev
Depends:
 ${misc:Depends},
 libstdgpu-openmp0t64 (= ${binary:Version}),
 libthrust-dev,
Description: ${source:Synopsis} (OpenMP development headers)
 ${source:Extended-Description}
 .
 This package installs the development headers for the OpenMP version.

Package: libstdgpu-hip0d
Architecture: amd64 ppc64el
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (HIP backend)
 ${source:Extended-Description}
 .
 This package installs the shared library that runs with HIP.

Package: libstdgpu-hip-dev
Section: libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Conflicts: libstdgpu-dev
Provides: libstdgpu-dev
Depends:
 ${misc:Depends},
 libstdgpu-hip0d (= ${binary:Version}),
 librocthrust-dev,
Description: ${source:Synopsis} (HIP development headers)
 ${source:Extended-Description}
 .
 This package installs the development headers for the HIP version.
