## stdgpu 1.3.0+git20220507.32e0517

=== debian/changelog ===
stdgpu (1.3.0+git20220507.32e0517-6ubuntu1) noble; urgency=medium

  * Merge from Debian experimental. Remaining changes:
    - Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Apr 2024 19:25:58 +0200

stdgpu (1.3.0+git20220507.32e0517-6) unstable; urgency=medium

  * Skip testing on armhf and armel (Closes: #1064019)

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Apr 2024 16:10:56 +0200

stdgpu (1.3.0+git20220507.32e0517-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable (Closes: #1062926)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 18:26:27 +0200

stdgpu (1.3.0+git20220507.32e0517-5.1~exp3ubuntu1) noble; urgency=medium

  * Merge from Debian experimental. Remaining changes:
    - Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures
      (LP: #2061253)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 15:06:05 +0200

stdgpu (1.3.0+git20220507.32e0517-5.1~exp3) experimental; urgency=medium

  * Fix debian/rules to not change the upstream soname.

 -- Steve Langasek <vorlon@debian.org>  Sun, 25 Feb 2024 20:41:43 +0000

stdgpu (1.3.0+git20220507.32e0517-5.1~exp2) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.
  * Fix wrong debian/control handling in previous upload.  Closes: #1063069.

 -- Steve Langasek <vorlon@debian.org>  Sun, 18 Feb 2024 00:39:25 +0000

stdgpu (1.3.0+git20220507.32e0517-5ubuntu1) noble; urgency=medium

  * Drop arm64 from libstdgpu-hip-dev and libstdgpu-hip0d architectures
    (LP: #2061253)

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 13 Apr 2024 15:32:28 -0600

stdgpu (1.3.0+git20220507.32e0517-5) unstable; urgency=medium

  * Fix wrong alignment test to actually provoke wrong alignment

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 23:13:20 +0200

stdgpu (1.3.0+git20220507.32e0517-4) unstable; urgency=medium

  * Fix Build-Depend on librocthrust-dev and libthrust-dev

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 11:29:46 +0200

stdgpu (1.3.0+git20220507.32e0517-3) unstable; urgency=medium

  * Handle architecture-dependent signedness of char and wchar_t
  * Limit HIP build to supported architectures

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Jul 2023 10:59:15 +0200

stdgpu (1.3.0+git20220507.32e0517-2) unstable; urgency=medium

  * Source-only upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Thu, 15 Jun 2023 23:30:28 +0200

stdgpu (1.3.0+git20220507.32e0517-1) experimental; urgency=medium

  * Initial release. (Closes: #1037131)

 -- Timo Röhling <roehling@debian.org>  Mon, 05 Jun 2023 21:38:21 +0200
