=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/stotko/stdgpu/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@
